
#include <array>     /* std::array */
#include <iostream>  /* std::cout */
#include "account.h"

int main(int argc, const char *argv[])
{
    CurrentAccount         a0(0, 2000);
    BlockedSavingAccount   a1(1, 50000);
    UnblockedSavingAccount a2(2, 100000);

    a0.debit(2500);     /* 2000€ debited (current account)   */
    a1.debit(20000);    /* 0€ debited    (blocked account)   */
    a2.debit(100001);   /* 0€ debited    (unblocked account) */

    std::cout << "All accounts:" << std::endl;
    std::cout << a0 << a1 << a2 << std::endl;
    
    std::cout << "Trying to debit and credit money:" << std::endl;
    std::array<Account*,3> accounts = {&a0, &a1, &a2};
    for (Account* acc : accounts) {
        std::cout << "  debiting and crediting account number " << (*acc)() << "..." << std::endl;
        acc->debit(2000);  /* will call Account::debit()  */
        acc->credit(1000); /* will call Account::credit() */
    }
    std::cout << std::endl;
    
    std::cout << "All accounts:" << std::endl;
    std::cout << a0 << a1 << a2 << std::endl;

    return EXIT_SUCCESS;
}
