
#ifndef CLIENT_H
#define CLIENT_H

#include <string>  /* std::string */
#include "account.h"

class Client {
    friend std::ostream& operator<<(std::ostream& os, const Client& client);
    private:
        std::string m_name;
        unsigned int m_identifier, m_ncurrent, m_nmax;
        Account** m_accounts;
    public:
        Client(std::string name="", unsigned int identifier=0, unsigned int max_accounts=8u);
        Client(const Client& client);
        ~Client();

        void create_account(unsigned int type=0u);
        void credit_account(unsigned int k, double amount);
        double debit_account(unsigned int k, double amount);
        unsigned int identifier() const;
};

#endif /* end of include guard: CLIENT_H */
