
#include <iostream>  /* std::cout   */
#include <string>    /* std::string */
#include <ctime>     /* std::time   */
#include <cstdlib>   /* std::rand, std::srand  */
#include "bank.h"

int main(int argc, const char *argv[])
{
    /* initialize random seed */
    std::srand(std::time(nullptr));

    const unsigned int nclients      = 5u;
    const unsigned int ntransactions = 32u;
    const unsigned int max_accounts  = 4u;

    const std::string names[nclients] = {
        "Mike C.", "Charlie M.", "David D.", "John A.", "Peter Q."
    };
    
    Bank bank;
    for (unsigned int i=0; i<nclients; i++) {
        const unsigned int naccounts = static_cast<unsigned int>(std::rand()) % (max_accounts+1);
        Client* client = new Client(names[i], i, naccounts);
        for (unsigned int j=0; j<naccounts; j++) {
            client->create_account(1u+static_cast<unsigned int>(std::rand()%3));
            for (unsigned int k=0; k<ntransactions; k++) {
                const double amount = 0.01*(std::rand() % 1000000);
                if (std::rand()%2) {
                    client->credit_account(j, amount);
                }
                else {
                    client->debit_account(j, amount);
                }
            }
        }
        bank.insert_client(*client);
    }

    std::cout << bank << std::endl;

    return EXIT_SUCCESS;
}
